// Copyright (C) 1999 Dominic Letourneau

#ifndef _NOT_H_
#define _NOT_H_

#include "Node.h"
#include "Exception.h"

/** 
    The NOT Node takes an input (bools) and returns the
    NOT result.
    - INPUTS : INPUT (bool)
    - OUTPUTS: OUTPUT (bool)
    @author Dominic Letourneau
    @version 1.0
 */
class NOT : public Node {

public:

   ///Constructor, takes the name of the node and a set of parameters
   NOT(string nodeName, ParameterSet params);

   /**Ask for the node's output which ID (number) is output_id 
      and for the 'count' iteration */
   virtual ObjectRef getOutput(int output_id, int count); 

   void specificInitialize() {processCount=-1;Node::specificInitialize();}

   void reset() {processCount=-1;Node::reset();}


protected:
   
   /// The input ID
   int inputID;
   
   /// The output ID
   int outputID;

   int processCount;

   ///the bool output (NOT)
   ObjectRef output;

   ///Default constructor, should not be used
   NOT() {throw(GeneralException("NOT default constructor should not be called",__FILE__,__LINE__));}

};
#endif
